#ifndef _huffman_h_
#define _huffman_h_

#include "bitstream.h"

typedef struct{
    unsigned short Code;
    unsigned char  Length;
    signed char    Value;
} HuffmanTyp;

extern const HuffmanTyp HuffHdr[10];
extern const HuffmanTyp HuffDSCF[16];
extern const HuffmanTyp * const Entropie[18];
extern const unsigned char Entropie_Len[18];
extern const HuffmanTyp DSCF_Entropie[13];
extern const HuffmanTyp Region_A[16],Region_B[8],Region_C[4];

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

extern int Huffman_Decode_fastest(Bit_stream_struc *, const HuffmanTyp *, int);
extern int Huffman_Decode_SCFI(Bit_stream_struc *);
extern int Huffman_Decode_Q(Bit_stream_struc*, int);
extern int SCFI_Bundle_read(Bit_stream_struc *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif