#ifndef _mppdec_h_
#define _mppdec_h_

#include "synth.h"

/***********************************************************************
*
*  Decoder Type Definitions
*
***********************************************************************/

#define DELAY 481

/* Parent Structure Interpreting some Frame Parameters in Header */
typedef struct{
    synth_struct        ss;
    fixed_t             Y[12][2][32];
    signed short        Q[32][2][36];        //quantisierte Samples
    signed char         Res[2][32];          //Aufloesungsstufen der Teilbaender
    unsigned char       SCFI[2][32];         //Uebertragungsreihenfolge der SCF
    signed char         SCF_Index[2][32][3]; //Skalenfaktor-Indizes fuer Speicherung
    unsigned char       MS_Flag[32];         //subbandweiser Flag fuer M/S-Signalfuehrung
    unsigned char       StreamVersion;
    unsigned char       Blockgroesse;
    unsigned short      Bitrate;
    unsigned char       IS_Flag;
    unsigned char       MS_used;
    unsigned char       Max_Band, Min_Band;
    unsigned long       OverallFrames;
    unsigned long       N;
    unsigned long       CurrBlkSize;
    unsigned char       TrueGaplessPresent;
    unsigned short      LastValidSamples;
    unsigned short      SampleRate;
} mpc_params;

#endif