;*****************************************************************************
;
; SYNTHCALSAMPLE.S - perform synthesis of subband samples(ISO-11172-3).
;
; Copyright (c) 2000 START GROUP.
;
;*****************************************************************************

;*****************************************************************************
;
; Read-only code area.
;
;*****************************************************************************
    AREA    |Assembly$$code|, CODE, READONLY

;*****************************************************************************
;
; sample calculate 32 samples.
;   sample(mad_fixed_t *evenp, mad_fixed_t *oddp, mad_fixed_t*even2p,
;          unsigned char *even, unsigned char *odd,
;          mad_fixed_t const *Dptr, short *pcmptr)
;
;*****************************************************************************
    EXPORT   sample
sample
    stmdb    r13!, {r4-r12,lr}
    ldr      r5,[r13,#0x2c]         ;r5=phase
    bic      r6,r5,#1               ;r6=pe
    sub      r7,r5,#1
    and      r7,r7,#0xf
    orr      r5,r7,#1               ;r5=po

    add      r4,r3,r5,lsl #2        ;ptr = *Dptr + po;

    ldr      r9,[r1]
    ldr      r10,[r4]
    smull    r7,r8,r9,r10
    ldr      r9,[r1, #4]
    ldr      r10,[r4,#56]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #8]
    ldr      r10,[r4,#48]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #12]
    ldr      r10,[r4,#40]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #16]
    ldr      r10,[r4,#32]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #20]
    ldr      r10,[r4,#24]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #24]
    ldr      r10,[r4,#16]
    smlal    r7,r8,r9,r10
    ldr      r9,[r1, #28]
    ldr      r10,[r4,#8]
    smlal    r7,r8,r9,r10

    add      r4,r3,r6,lsl #2        ;ptr = *Dptr + pe;

    ldr      r9,[r0]
    ldr      r10,[r4]
    smull    r11,r12,r9,r10
    ldr      r9,[r0,#4]
    ldr      r10,[r4,#56]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#8]
    ldr      r10,[r4,#48]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#12]
    ldr      r10,[r4,#40]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#16]
    ldr      r10,[r4,#32]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#20]
    ldr      r10,[r4,#24]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#24]
    ldr      r10,[r4,#16]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#28]
    ldr      r10,[r4,#8]
    smlal    r11,r12,r9,r10

    subs     r7,r11,r7
    sbc      r8,r12,r8
    mov      r7, r8, asr #9
    ldr      r4,[r13,#0x28]         ;r4=outsamp
    strh     r7,[r4]

    mov      r14, #2
rep
    add      r0,r0,#32
    add      r3,r3,#128

    str      r14,[r13,#-4]

    add      r1,r3,r5,lsl #2        ;ptr = *Dptr + po;
    sub      r14,r3,r5,lsl #2       ;ptr = *Dptr - po;

    ldr      r9,[r2]
    ldr      r10,[r1]
    smull    r7,r8,r9,r10
    ldr      r10,[r14,#60]
    smull    r11,r12,r9,r10
    ldr      r9,[r2, #4]
    ldr      r10,[r1,#56]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#68]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #8]
    ldr      r10,[r1,#48]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#76]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #12]
    ldr      r10,[r1,#40]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#84]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #16]
    ldr      r10,[r1,#32]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#92]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #20]
    ldr      r10,[r1,#24]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#100]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #24]
    ldr      r10,[r1,#16]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#108]
    smlal    r11,r12,r9,r10
    ldr      r9,[r2, #28]
    ldr      r10,[r1,#8]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#116]
    smlal    r11,r12,r9,r10

    rsbs     r7,r7,#0
    rsc      r8,r8,#0

    add      r1,r3,r6,lsl #2        ;ptr = *Dptr + pe;
    sub      r14,r3,r6,lsl #2       ;ptr = *Dptr - pe;

    ldr      r9,[r0]
    ldr      r10,[r1]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#60]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#4]
    ldr      r10,[r1,#56]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#68]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#8]
    ldr      r10,[r1,#48]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#76]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#12]
    ldr      r10,[r1,#40]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#84]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#16]
    ldr      r10,[r1,#32]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#92]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#20]
    ldr      r10,[r1,#24]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#100]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#24]
    ldr      r10,[r1,#16]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#108]
    smlal    r11,r12,r9,r10
    ldr      r9,[r0,#28]
    ldr      r10,[r1,#8]
    smlal    r7,r8,r9,r10
    ldr      r10,[r14,#116]
    smlal    r11,r12,r9,r10

    add      r2,r2,#32

    ldr      r14,[r13,#-4]

    mov      r7, r8, asr #9
    strh     r7,[r4,r14]
    mov      r11, r12, asr #9
    rsb      r7,r14,#0x40
    strh     r11,[r4,r7]

    add      r14,r14,#2
    cmp      r14,#32
    bne      rep

    add      r3,r3,#128

    add      r1,r3,r5,lsl #2        ;ptr = *Dptr + po;

    ldmia    r2,{r0,r2,r3,r5,r6,r9,r11,r12}
    ldr      r10,[r1]
    smull    r7,r8,r0,r10
    ldr      r10,[r1,#56]
    smlal    r7,r8,r2,r10
    ldr      r10,[r1,#48]
    smlal    r7,r8,r3,r10
    ldr      r10,[r1,#40]
    smlal    r7,r8,r5,r10
    ldr      r10,[r1,#32]
    smlal    r7,r8,r6,r10
    ldr      r10,[r1,#24]
    smlal    r7,r8,r9,r10
    ldr      r10,[r1,#16]
    smlal    r7,r8,r11,r10
    ldr      r10,[r1,#8]
    smlal    r7,r8,r12,r10

    rsb      r8,r8,#0
    mov      r7, r8, asr #9
    strh     r7,[r4,#32]

    ldmia    r13!, {r4-r12,pc}

    END
    