;*****************************************************************************
;
; BITSTREAM.S - bitstream decoder.
;
; Copyright (c) 2000 START GROUP.
;
;*****************************************************************************

;*****************************************************************************
;
; Read-only code area.
;
;*****************************************************************************

    AREA    |Assembly$$code|, CODE, READONLY

;*****************************************************************************
;
; get_bits gets number of bits (r1) from bitstream (r0).
;
;*****************************************************************************
    EXPORT   get_bits
get_bits
    rsb      r12,r1,#0x20
    ldmia    r0,{r2,r3}
    ldr      r1,[r2,#0]
    mov      r1,r1,lsl r3
    mov      r1,r1,lsr r12
    subs     r12,r12,r3
    addlt    r12,r12,#0x20
    ldrlt    r3,[r2,#4]!
    strlt    r2,[r0,#0]
    rsb      r2,r12,#0x20
    str      r2,[r0,#4]
    orrlt    r0,r1,r3,lsr r12
    movge    r0,r1
    mov      pc,lr
    
;*****************************************************************************
;
; preview_bits preview number of bits (r1) from bitstream (r0).
;
;*****************************************************************************
    EXPORT   preview_bits
preview_bits
    ldmia    r0,{r2,r3}
    ldr      r0,[r2,#0]
    mov      r0,r0,lsl r3
    rsb      r1,r1,#0x20
    mov      r0,r0,lsr r1
    subs     r1,r1,r3
    addlt    r1,r1,#0x20
    ldrlt    r3,[r2,#4]
    orrlt    r0,r0,r3,lsr r1
    mov      pc,lr
        
;*****************************************************************************
;
; ignore_bits ignore number of bits (r1) from bitstream (r0).
;
;*****************************************************************************
    EXPORT   ignore_bits
ignore_bits
    ldmia    r0,{r2,r3}
    add      r3,r3,r1
    mov      r1,r3,asr #5
    add      r2,r2,r1,lsl #2
    and      r3,r3,#0x1f
    stmia    r0,{r2,r3}
    mov      pc,lr

;*****************************************************************************
;
; put_bits puts value (r1) of number of bits (r2) to bitstream (r0).
;
;*****************************************************************************
    EXPORT   put_bits
put_bits
    stmdb    r13!,{r4, r14}
    ldmia    r0, {r3, r4}
    ldr      r12, [r3]
    rsb      r14, r2, #32
    mov      r1, r1, lsl r14
    orr      r12, r12, r1, lsr r4
    cmp      r4, r14
    addls    r4, r4, r2
    strls    r12, [r3]
    strls    r4, [r0, #4]
    ldmlsia  r13!,{r4, pc}
    eor      r2, r12, r12, ror #16
    bic      r2, r2, #0xff0000
    mov      r12, r12, ror #8
    eor      r12, r12, r2,lsr #8
    str      r12, [r3], #4
    rsb      r2, r4, #32
    mov      r12, r1, lsl r2
    sub      r4, r4, r14
    str      r12, [r3]
    stmia    r0, {r3, r4}
    ldmia    r13!,{r4, pc}
    
;*****************************************************************************
;
; flush_bits flushs bitstream (r0).
;
;*****************************************************************************
    EXPORT   flush_bits
flush_bits
    ldmia    r0, {r1, r2}
    cmp      r2, #0
    moveq    pc, r14
    ldr      r3, [r1]
    eor      r2, r3, r3, ror #16
    bic      r2, r2, #0xff0000
    mov      r3, r3, ror #8
    eor      r3, r3, r2, lsr #8
    str      r3, [r1]
    mov      pc, lr
    
    END
